﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using Petzold.Media3D;

namespace TaperTransformExperiment
{
    public partial class MainPage : UserControl
    {
        TaperTransform taperTransform = new TaperTransform();

        public MainPage()
        {
            InitializeComponent();
            taperTransform.Matrix3DChanged += OnTaperTransformMatrix3DChanged;
        }

        void OnTaperTransformMatrix3DChanged(object sender, EventArgs args)
        {
            projection.ProjectionMatrix = taperTransform.Matrix3D;
        }

        void OnScrollBarValueChanged(object sender, RoutedPropertyChangedEventArgs<double> args)
        {
            taperTransform.TaperFraction = args.NewValue;
        }

        void OnImageOpened(object sender, RoutedEventArgs args)
        {
            Image img = (sender as Image);
            BitmapImage bitmap = img.Source as BitmapImage;

            if (bitmap != null)
            {
                taperTransform.TargetWidth = bitmap.PixelWidth;
                taperTransform.TargetHeight = bitmap.PixelHeight;
            }
        }

        void OnTaperSideRadioButtonChecked(object sender, RoutedEventArgs args)
        {
            RadioButton btn = sender as RadioButton;
            TaperSide taperSide = (TaperSide)Enum.Parse(typeof(TaperSide), btn.Tag as string, true);
            taperTransform.TaperSide = taperSide;
        }

        void OnTaperCornerRadioButtonChecked(object sender, RoutedEventArgs args)
        {
            RadioButton btn = sender as RadioButton;
            TaperCorner taperCorner = (TaperCorner)Enum.Parse(typeof(TaperCorner), btn.Tag as string, true);
            taperTransform.TaperCorner = taperCorner;
        }
    }
}
